function Msg(value)

    reaper.ShowConsoleMsg(tostring(value) .. "\n")

end


function main()
--[[
  retval, bpm = reaper.GetUserInputs("Set Constant Tempo", 1, "Enter tempo (bpm):", "" )
  
  if not retval then
     reaper.defer(function () end)
     return   
  end 
--]]


  org_cur_pos =  reaper.GetCursorPosition(0)
  retval, grid, swingmodeIn, swingamtIn = reaper.GetSetProjectGrid( 0, false )
  bpm, beat_per_measure = reaper.GetProjectTimeSignature2(0)
  item = reaper.GetSelectedMediaItem(0, 0)
  if not item then
     reaper.MB("Select Item", "Select an Item", 0)
     reaper.defer(function () end)
     return
  end 
  take = reaper.GetMediaItemTake(item, 0)
  item_pos = reaper.GetMediaItemInfo_Value( item, "D_POSITION" )
  reaper.SetMediaItemTakeInfo_Value( take, "D_PLAYRATE", 2 )
  take_pcm_source = reaper.GetMediaItemTake_Source(take)
  media_length, length_is_QN = reaper.GetMediaSourceLength( take_pcm_source )
  measure_length = reaper.GetMediaItemInfo_Value( item, "C_BEATATTACHMODE", 1 ) 
  retval, bpm = reaper.GetUserInputs("Set Item's Original Tempo", 1, "Enter item's tempo (bpm):", "" )
    
 if retval then  
  beat = (((grid * beat_per_measure)/ bpm) * 60)
  pos = 0
  reaper.SetTakeStretchMarker( take, -1, pos, srcposIn ) -- initial stretch marker
  while (pos < media_length) do
      pos = pos + beat
      reaper.SetTakeStretchMarker( take, -1, pos, srcposIn )
      
  end    
  
   
  item_pos = reaper.GetMediaItemInfo_Value( item, "D_POSITION" )
  reaper.SetEditCurPos( item_pos, 0, 0 )
 

   cur_pos =  reaper.GetCursorPosition(0)
   item = reaper.GetSelectedMediaItem(0, 0) 
   take = reaper.GetMediaItemTake(item, 0)
   reaper.SetMediaItemTakeInfo_Value( take, "D_PLAYRATE", 1 )   
   stretch_count = reaper.GetTakeNumStretchMarkers( take )
  for i = 0, stretch_count do    
   retval, pos, srcpos = reaper.GetTakeStretchMarker( take, i )
   if pos >= item_pos then idx = i break end
  end 
   
   cur_pos =  reaper.GetCursorPosition(0)
   item_length = reaper.GetMediaItemInfo_Value( item, "D_LENGTH" ) 
   reaper.SetEditCurPos( item_pos, 0, 0 )
   idx = 0
   --reaper.MB("Ok", "Paused", 0)
  --while (cur_pos < item_length) do
  while (idx < stretch_count) do
     idx = idx +1
     reaper.Main_OnCommand(40647, 0)  -- View: Move cursor right to grid division     
     cur_pos =  reaper.GetCursorPosition(0)
     reaper.SetTakeStretchMarker( take, idx, cur_pos - item_pos)
     reaper.SetEditCurPos( cur_pos, 0, 0 )
     item_length = reaper.GetMediaItemInfo_Value( item, "D_LENGTH" )
     cur_pos =  reaper.GetCursorPosition(0)
     if cur_pos == item_length then break end
     --if idx < 10 then reaper.MB("Ok", "Paused", 0) end
     
     
  end

  retval, pos, srcpos = reaper.GetTakeStretchMarker( take, stretch_count -1 )
  reaper.SetMediaItemLength( item, pos, true )
  reaper.Main_OnCommand(41173, 0) -- Item navigation: Move cursor to start of items
    
   
 end  
  
  
end

reaper.PreventUIRefresh(1)

reaper.Undo_BeginBlock()

main()

reaper.UpdateArrange()
reaper.UpdateTimeline()

reaper.Undo_EndBlock( "ReaTrak set item bpm and fit to project tempo map", - 1 )

reaper.PreventUIRefresh(-1)
